function [Tx,Wbb] = findmode1(Wbb,as1,Fb,Fc,j0,t0,Gkopt,nbmode,nbmoy,nv,na,cas2)
% find the mode when the number of detected modes is larger than the
% expected one

[Las,N] = size(Wbb);
Tx = zeros(nbmoy,N);

for k=1:nbmoy,
  
  % if (k == 2)
  %  plot(nbmode)
  %  pause
  %end
  
  j1cour = 0;
  j2cour = 0;
  for b= t0:N %we move forward first
     j=2;
     
     %if (k == 2)&&(b>700)&&(b <800)
     % b
     % nbmode(b)
     % j1cour
     % j2cour
     %end
     
     while (j <= Las)
       if ((abs(Wbb(j,b)) > Gkopt)&&(abs(Wbb(j-1,b)) < Gkopt)) 
         %we only consider the coefficients larger than Gkopt
        
        if (b == t0)
        
          j1cour  = j; j1cour0 = j1cour; %we mark the first point
          j  = j+1;
          
          while (abs(Wbb(j,b)) > Gkopt)
             j=j+1;
          end
         
          j2cour  = j-1;
          j2cour0 = j2cour;
         
          if cas2 == 1 
            center = Fc./as1(round((j2cour+j1cour)/2)); %we compute the center given by the interval  
            J=1:na-j0+1;
            index = (Fc-Fb < as1*center)&(as1*center < Fc+Fb);
            index = J(index);
            Tx(k,b) = sum(real(Wbb(index,b)))*log(2)/nv;
          else
            Tx(k,b) = sum(real(Wbb(j1cour:j2cour,b)))*log(2)/nv; 
          end
          Wbb(j1cour:j2cour,b) = 0;
          j = Las+1;
        
       elseif (nbmode(b) >= nbmoy)
            
          if (j1cour ~= 0)  
           
           % we test whether there are several candidates or none  
             
           cand  = 0;
            
           while (j <= j2cour) 
             if (abs(Wbb(j,b)) > Gkopt)
               j1 = j;
               j  = j+1;
               while (abs(Wbb(j,b)) > Gkopt)
                j=j+1;
               end
               j2 = j-1; 
               if ((j1 <= j2cour) && (j2 >= j1cour)) 
                cand=cand+1;                
                if cand == 1
                 ind1 = j1; 
                 ind2 = j2; 
                else
                 ind1 = [ind1 j1];
                 ind2 = [ind2 j2];
                end 
                j = j2+1;
               else
                j = j2+1;
               end
             else  
              j=j+1;
             end 
           end
           
           if (cand > 0) 
             
            [val ind] = max(ind2-ind1);
            j1cour    = ind1(ind(1));
            j2cour    = ind2(ind(1));
       
            if cas2 == 1, 
                center = Fc./as1(round((j1cour+j2cour)/2)); %we compute the center given by the interval  
                J=1:na-j0+1;
                index = (Fc-Fb < as1*center)&(as1*center < Fc+Fb);
                index = J(index);
                Tx(k,b) = sum(real(Wbb(index,b)))*log(2)/nv;
            else
                Tx(k,b) = sum(real(Wbb(j1cour:j2cour,b)))*log(2)/nv;
            end
            for p =1:cand,
                Wbb(ind1(p):ind2(p),b)=0;
            end
           else
            j1cour = 0;
            j2cour = 0;
           end
           j = Las + 1;
          
          elseif (nbmode(b) == nbmoy)
              
           j1 = j;
           j  = j+1; 
           
           while (abs(Wbb(j,b)) > Gkopt)
            j=j+1;
           end
           
           j2 = j-1;
           j1cour = j1;
           j2cour = j2;
           
           if cas2 == 1, 
                center = Fc./as1(round((j1cour+j2cour)/2)); %we compute the center given by the interval  
                J=1:na-j0+1;
                index = (Fc-Fb < as1*center)&(as1*center < Fc+Fb);
                index = J(index);
                Tx(k,b) = sum(real(Wbb(index,b)))*log(2)/nv;
           else
                Tx(k,b) = sum(real(Wbb(j1cour:j2cour,b)))*log(2)/nv;
           end
           Wbb(j1:j2,b) = 0;
           j = Las+1;   
          else
           j = Las+1;   
          end
        else
         j = Las+1;    
        end
       else 
        j = j+1;
       end
     end
   end
  
  if (t0 > 1) 
   
   j1cour = j1cour0;
   j2cour = j2cour0;
   
   for b = t0-1:-1:1 % we now move backwards
       j = 2;
       while (j <= Las)
        if ((abs(Wbb(j,b)) > Gkopt)&&(abs(Wbb(j-1,b)) < Gkopt)) 
          
          if (nbmode(b) >= nbmoy)
           
           if (j1cour ~= 0) 
 
            cand  = 0;
          
            while (j <= j2cour) 
             if (abs(Wbb(j,b)) > Gkopt)
               j1 = j;
               j  = j+1;
               while (abs(Wbb(j,b)) > Gkopt)
                j=j+1;
               end
               j2 = j-1; 
               if ((j1 <= j2cour) && (j2 >= j1cour)) 
                cand=cand+1;                
                ind1(cand) = j1; 
                ind2(cand) = j2; 
                j = j2+1;
               else
                j = j2+1;
               end
             else  
              j=j+1;
             end 
            end
                       
            if (cand > 0) 
             
             [val ind] = max(ind2-ind1);
             j1cour    = ind1(ind(1));
             j2cour    = ind2(ind(1));
             
             if cas2 == 1, 
                center = Fc./as1(round((j1cour+j2cour)/2)); %we compute the center given by the interval  
                J=1:na-j0+1;
                index = (Fc-Fb < as1*center)&(as1*center < Fc+Fb);
                index = J(index);
                Tx(cand,b) = sum(real(Wbb(index,b)))*log(2)/nv;
             else
                Tx(cand,b) = sum(real(Wbb(j1cour:j2cour,b)))*log(2)/nv;
             end
             for p =1:cand,
                Wbb(ind1(p):ind2(p),b)=0;
             end
            else
             j1cour = 0;
             j2cour = 0;
            end
            j = Las + 1;
           elseif (nbmode(b) == nbmoy)
            j1 = j;
            j  = j+1; 
           
            while (abs(Wbb(j,b)) > Gkopt)
             j=j+1;
            end
           
            j2 = j-1;
            j1cour = j1;
            j2cour = j2;
           
            if cas2 == 1, 
                center = Fc./as1(round((j1cour+j2cour)/2)); %we compute the center given by the interval  
                J=1:na-j0+1;
                index = (Fc-Fb < as1*center)&(as1*center < Fc+Fb);
                index = J(index);
                Tx(k,b) = sum(real(Wbb(index,b)))*log(2)/nv;
            else
                Tx(k,b) = sum(real(Wbb(j1cour:j2cour,b)))*log(2)/nv;
            end
            Wbb(j1:j2,b) = 0;
            j = Las+1;   
           else
            j = Las+1;   
           end
          else
           j = Las+1;   
          end
       else
         j = j+1;
       end
       end 
    end
   end
  end
 end

  

