function [Wbb,as1,na,nv,j0] = wavedecomp(Fb,Fc,cas,s,t,dt)

% cas == 2, bump wavelet, cas == 1, Morlet wavelet, cas = 3 window wavelet

nv = 32; % nbre coefs par octave
N = length(s);
noct = log2(N)-1;
na = noct*nv;
if (cas == 2)||(cas == 3),
 j0 = nv*((log(2)+log(Fc+Fb))/log(2)); %voir explication pour j0
else
 Delta = sqrt(log(2)/(2*Fb*pi^2));    
 j0 = nv*(log(2)+log(Delta+Fc));
end

as = (2^(1/nv).^(j0:1:na));
as1 = as*dt;
T = t(end);

%les frequences pour la TF
lfm = (0:N-1)/T;

fts = fft(s); %on veut avoir le meme resultat independamment de la taille du signal
Las = length(as);
Wbb = zeros(Las,N);


%Transformee de Fourier de l'ondelette Bump

for j = 1:Las,
 if cas == 2,
  for k=1:length(lfm)
   if k == 1,
      if abs((as1(j)*lfm(k)-Fc)/Fb) < 1
         FouPsi = exp(1-(1/(1-((as1(j)*lfm(k)-Fc)/Fb)^2)));
      else
         FouPsi = 0;  
      end
   else
      if abs((as1(j)*lfm(k)-Fc)/Fb) < 1
          FouPsi = [FouPsi exp(1-(1/(1-((as1(j)*lfm(k)-Fc)/Fb)^2)))];
      else
          FouPsi = [FouPsi 0];      
      end
   end
  end
  
 elseif cas == 3,
   for k=1:length(lfm)  
    if k == 1,
     if abs((as1(j)*lfm(k)-Fc)/Fb) < 1
         FouPsi = 1;
     else
         FouPsi = 0;  
     end
    else
     if abs((as1(j)*lfm(k)-Fc)/Fb) < 1
       FouPsi = [FouPsi 1];
     else
       FouPsi = [FouPsi 0];      
     end
    end
   end 
 else
  for k=1:length(lfm)  
   if k == 1,
     FouPsi = exp(-Fb*pi^2*(as1(j)*lfm(k)-Fc)^2);
   else
     FouPsi = [FouPsi exp(-Fb*pi^2*(as1(j)*lfm(k)-Fc)^2)];
   end
  end
 end
 Wb = ifft(fts.*FouPsi);
 Wbb(j,:) = Wb;
end



end

